<?php
/*
Plugin Name: Copy Compass
Plugin URI: http://www.copycompass.co.za/
Description: Analyse the content of your posts and pages against search engine optimisation best practises.
Version: 1.3.0
Author: Talooma (Nick Duncan)
Author URI: http://talooma.com
*/



add_action('admin_menu', 'cc_add_custom_box');
add_action('admin_head', 'cc_head');
add_action('admin_notices', 'cc_overlay');
add_action('init', 'cc_load_jquery');
add_action('save_post', 'cc_save_postdata');
add_action('admin_menu', 'cc_admin_menu');
add_action('admin_notices', 'cc_warning');


function cc_load_jquery() {
    @session_start();
    $_SESSION['cc_dir'] = get_plugin_url();
    wp_enqueue_script("jquery");


}
function get_plugin_url() {
    if ( !function_exists('plugins_url') )
        return get_option('siteurl') . '/wp-content/plugins/' . plugin_basename(dirname(__FILE__));
        return plugins_url(plugin_basename(dirname(__FILE__)));
}

function cc_head() {
    $cc_data = get_option('CopyCompass');
    $cc_apikey = $cc_data['api'];
    echo '
        <script type="text/javascript">

            var $j = jQuery.noConflict();

            $j(document).ready(function(){
               $j("#cc_btn").click(function(){

                    var normt = "0";
                    var pspt = "0";
                    var pspdsc = "0";
                    var aiodsc = "0";
                    var aiot = "0";

                    var content = tinyMCE.get(\'content\').getContent();

                    var normt = $j("#title").val();

                    if (document.getElementsByName("psp_description").length > 0) { pspdsc = document.post.psp_description.value; }
                    if (document.getElementsByName("psp_title").length > 0) { pspt = document.post.psp_title.value; }
                    if (document.getElementsByName("aiosp_description").length > 0) { aiodsc = document.post.aiosp_description.value; }
                    if (document.getElementsByName("aiosp_title").length > 0) { aiot = document.post.aiosp_title.value; }

                    content = content.replace("+", "%2B");
                    content = content.replace("/", "%2F");
                    content = content.replace(/\x26/g,"%26");

                    pspdsc = pspdsc.replace(/\x26/g,"%26");
                    aiodsc = aiodsc.replace(/\x26/g,"%26");

                    $j("#aa_loader").fadeIn("fast");
                    $j("#aa_loader").html("<small>Analyzing...</small>");

                    $j.ajax({
                       type: "POST",
                       data: "api='.$cc_apikey.'"+"&normt="+normt+"&pspdsc="+pspdsc+"&pspt="+pspt+"&aiodsc="+aiodsc+"&aiot="+aiot+"&content="+content,
                       url: "'.get_plugin_url().'/includes/cFKre.php",
                       success: function(msg)
                       {
                            tb_show("Copy Compass", "'.get_plugin_url().'/display.php?TB_iframe=true&width=200");

                            var screenwidth = $j(window).width();
                            var screenheight = $j(window).height();
                            var new_screenwidth = screenwidth / 2;
                            var new_left_margin = screenwidth / 4;

                            $j("#TB_window, #TB_iframeContent").css({"width": new_screenwidth});
                            $j("#TB_window").css({"margin-left": -new_left_margin});
                            $j("#aa_loader").fadeOut("fast");
                            $j("#cc_data").html(msg);


                       }
                    });


                });

                $j("#cc_register_btn").click(function(){
                   $j("#cc_register_box").toggle();

                });
                $j("#cc_register_api").click(function(){
                    $j("#cc_loading").html("<small>getting information....</small>");
                    var cc_email_check = $j("#cc_email").val();
                    $j.ajax({
                       type: "POST",
                       data: "email="+cc_email_check,
                       url: "'.get_plugin_url().'/includes/generate-api.php",
                       success: function(msg)
                       {
                            if (msg.length < 5) { $j("#cc_errors").html("<span style=\"color:red\">There was an error with your request. Please ensure you have inputted a VALID email address. Otherwise try again later or contact Copy Compass via the website.</span>"); }
                            else {
                                $j("#cc_register_box").toggle();
                                $j("#cc_apikey_get").html("Your API key is: <span style=\"font-size:14px; color:blue; font-weight:bold;\">"+msg+"</span>");
                            }
                            $j("#cc_loading").html("");
                            
                       }
                    });

                });


            });
        </script>

        <style>
            #cc_btn {
                background: #21759B url('.get_option('siteurl').'/wp-admin/images/'.'button-grad.png) repeat-x scroll 0% 0%;
                border-color: #298CBA;
                color: white;
                font-weight: bold;
                width:80px;
                height:20px;
                -webkit-box-sizing: content-box;
                border-bottom-left-radius: 11px 11px;
                border-bottom-right-radius: 11px 11px;
                border-style: solid;
                border-width: 1px;
                border-top-left-radius: 11px 11px;
                border-top-right-radius: 11px 11px;
                cursor: pointer;
                font-size: 11px !important;
                line-height: 14px;
                padding: 4px 16px;
                text-decoration: none;
                margin:5px;
                margin-right:0px;
                margin-top:20px;
            }
            
        </style>


    ';
}

function cc_add_custom_box() {

  if( function_exists( 'add_meta_box' )) {
    add_meta_box( 'myplugin_sectionid', __( 'Copy Compass', 'myplugin_textdomain' ),
                'cc_box', 'post', 'side', 'high' );
    add_meta_box( 'myplugin_sectionid', __( 'Copy Compass', 'myplugin_textdomain' ),
                'cc_box', 'page', 'side', 'high' );
   } else {
    add_action('dbx_post_advanced', 'cc_oldversion_box' );
    add_action('dbx_page_advanced', 'cc_oldversion_box' );
  }
}




function cc_overlay() {
    echo "
        <div id=\"cc_overlay_bg\" style=\"position:absolute; display:none; z-index:2000; height:100%; width:100%; margin:0; background-color:#000; filter:alpha(opacity=50); -moz-opacity:0.5; -khtml-opacity: 0.5; opacity: 0.5;\"></div>

        <div id=\"cc_overlay\" style=\"display:none; z-index:2001; left:20%; top:20%; width:60%; height:60%; border:20px solid #EEE; background-color:#FFF; padding:20px;\">
            <div id=\"cc_menu\">
                Menu
            </div>
            <div id=\"cc_overlay_content\">
                Content

            </div>

        </div>


    ";


}


function cc_admin_menu() {
    add_options_page('Copy Compass', 'Copy Compass', 'manage_options', 'copy-compass-menu', 'cc_menu_layout');
}
function cc_menu_layout() {



   if (isset($_POST['cc_apikey'])){
    $data['api'] = attribute_escape($_POST['cc_apikey']);
    update_option('CopyCompass', $data);
    $cc_data = get_option('CopyCompass');


    echo "
       <div class='wrap'>
            <h2>Copy Compass Settings</h2>
            <div class='narrow'>

                <div class='updated'>
                    Your settings have been saved.
                </div>

                <form action='' method='post' id='cc_options' style='margin: auto; width: 400px;'>
                <p></p>

                    <input type='hidden' name='http_referer' value='".$_SERVER['PHP_SELF']."' />
                    <h3><label for='key'>Copy Compass API Key</label></h3>
                        <p>API Key: <input id='cc_apikey' name='cc_apikey' type='text' size='15' maxlength='100' value='".$cc_data['api']."' style='font-family: \"Courier New\", Courier, mono; font-size: 1.5em;' />
                        (<a href='http://www.copycompass.co.za/what-is-the-copy-compass-api-key/'>What is this?</a>)</p>
                        <p>Don't have an API Key? Get one <a href='javascript:void(0);' title='Get your API Key' id='cc_register_btn'>here</a>.</p>
                        <p class='submit'><input type='submit' name='submit' value='Update options &raquo;' /></p>
                </form>
            </div>


            <div class='narrow'>
                <div style='display:block; margin:0 auto; width:400px; height:40px;'>
                    <p><span id='cc_apikey_get'></span></p>
                </div>
            </div>



            <div class='narrow' id='cc_register_box' style='display:none;'>
                <div style='display:block; margin:0 auto; width:400px;'>
                        <input type='hidden' name='http_referer' value='".$_SERVER['PHP_SELF']."' />
                        <h3><label for='key'>Request an API key</label></h3>
                            <p>Email Address: <input id='cc_email' name='cc_email' type='text' size='25' maxlength='70' value='' style='font-family: \"Courier New\", Courier, mono; font-size: 1.5em;' />
                            <p class='submit'><input type='submit' name='cc_register' id='cc_register_api' value='Register' /></p><span id='cc_loading'></span>
                            <p><span id='cc_errors'></span></p>
                            <p><span style='font-style:italic; font-size:11px;'>* only one API key is allowed per domain</span></p>

                    </form>
                </div>

            </div>
        </div>
        <div style='width:98%; border:1px solid #ccc; background-color:#2B2B2B; text-align:right; padding:10px; color:#FFF; letter-spacing:1px;'>
            Copy Compass is a <a href='http://talooma.com' title='talooma' border='0' target='_blank'><img src='http://copycompass.co.za/core/images/talooma_logo.jpg' alt='talooma' height='35'></a> product
        </div>


    ";


   }





   else {


        $cc_data = get_option('CopyCompass');

        echo "


        <div class='wrap'>
            <h2>Copy Compass Settings</h2>
            <div class='narrow'>
                <form action='' method='post' id='cc_options' style='margin: auto; width: 400px;'>
                <p></p>

                    <input type='hidden' name='http_referer' value='".$_SERVER['PHP_SELF']."' />
                    <h3><label for='key'>Copy Compass API Key</label></h3>
                        <p>API Key: <input id='cc_apikey' name='cc_apikey' type='text' size='15' maxlength='100' value='".$cc_data['api']."' style='font-family: \"Courier New\", Courier, mono; font-size: 1.5em;' />
                        (<a href='http://www.copycompass.co.za/what-is-the-copy-compass-api-key/'>What is this?</a>)</p>
                        <p>Don't have an API Key? Get one <a href='javascript:void(0);' title='Get your API Key' id='cc_register_btn'>here</a>.</p>
                        <p class='submit'><input type='submit' name='submit' value='Update options &raquo;' /></p>
                </form>
            </div>


            <div class='narrow'>
                <div style='display:block; margin:0 auto; width:400px; height:40px;'>
                    <p><span id='cc_apikey_get'></span></p>
                </div>
            </div>



            <div class='narrow' id='cc_register_box' style='display:none;'>
                <div style='display:block; margin:0 auto; width:400px;'>
                        <input type='hidden' name='http_referer' value='".$_SERVER['PHP_SELF']."' />
                        <h3><label for='key'>Request an API key</label></h3>
                            <p>Email Address: <input id='cc_email' name='cc_email' type='text' size='25' maxlength='70' value='' style='font-family: \"Courier New\", Courier, mono; font-size: 1.5em;' />
                            <p class='submit'><input type='submit' name='cc_register' id='cc_register_api' value='Register' /></p><span id='cc_loading'></span>
                            <p><span id='cc_errors'></span></p>
                            <p><span style='font-style:italic; font-size:11px;'>* only one API key is allowed per domain</span></p>

                    </form>
                </div>

            </div>
        </div>
        <div style='width:98%; border:1px solid #ccc; background-color:#2B2B2B; text-align:right; padding:10px; color:#FFF; letter-spacing:1px;'>
            Copy Compass is a <a href='http://talooma.com' title='talooma' border='0' target='_blank'><img src='http://copycompass.co.za/core/images/talooma_logo.jpg' alt='talooma' height='35'></a> product
        </div>


    ";

   }
}

function cc_box() {
    $data = get_option("CopyCompass");
    if ($data['api']) {

        echo '
            <div id="aa_buttondiv" style="text-align:center; width:100%; height:30px; margin-top:20px !important;">
                <img id=\'aa_ajaxloader\' src=\''.get_option('siteurl').'/wp-admin/images/'.'loading.gif\' style=\'vertical-align:middle; display:none;\' width=\'16\' height=\'16\' />
                <a href="javascript:void(0);" title="Analyze the content!" id="cc_btn" class="button_primary" align="center">Analyze Content</a><br />
                <div id="aa_loader" style="margin-top:5px; height:15px;"></div>
            </div>';
        echo "<div id=\"cc_data\" style='width:100%; overflow:auto;'></div>";

    }
    else {
        echo 'You need to register an API key before you can use Copy Compass.';
    }
}

/* Prints the edit form for pre-WordPress 2.5 post/page */
function cc_oldversion_box() {

  echo '<div class="dbx-b-ox-wrapper">' . "\n";
  echo '<fieldset id="myplugin_fieldsetid" class="dbx-box">' . "\n";
  echo '<div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">' .
        __( 'Copy Compass', 'myplugin_textdomain' ) . "</h3></div>";

  echo '<div class="dbx-c-ontent-wrapper"><div class="dbx-content">';

  // output editing form

  cc_box();

  // end wrapper

  echo "</div></div></fieldset></div>\n";
}





function cc_save_postdata( $post_id ) {


  if ( !wp_verify_nonce( $_POST['myplugin_noncename'], plugin_basename(__FILE__) )) {
    return $post_id;
  }

  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
    return $post_id;

  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ) )
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ) )
      return $post_id;
  }


  $mydata = $_POST['myplugin_new_field'];

   return $mydata;
}

function cc_warning() {
    $data = get_option("CopyCompass");
    if (!$data['api']) {
        echo "<div class='updated'>Copy Compass is almost ready. You need to <a href='options-general.php?page=copy-compass-menu' title='Request a Copy Compass API Key'>request an API Key</a> before continuing.</div>";
    }
}


?>